BSD-FAQ-it
Indietro | Capitolo 7. Lavorare con il Kernel | Avanti

# 7.7. Recuperare un vecchio Kernel

Come abbiamo detto prima, uno dei problemi maggiori può essere il famigerato Kernel panic, per eseguire il boot del sistema utilizzando il vecchio Kernel sarà necessario riavviare la macchina.

Al prompt di sistema, nel momento in cui viene avviato il conteggio dei 10 secondi che precedono il processo di boot, sarà possibile interrompere il processo premendo qualsiasi tasto ad eccezione di Enter. Nel caso si tratti di una versione 5.0 o successiva, al prompt dei comandi sarà necessario digitare il seguente comando

    # boot /boot/kernel.old

E' possibile eseguire il boot di sistema anche utilizzando altre versioni del Kernel, è fondamentale quindi aver precedentemente memorizzato le varie versioni del Kernel ricorrendo all'utilizzo di nomi diversi, per esempio /boot/kernel1.old.

Nel caso si stia utilizzando FreeBSD 4.7-STABLE o 4.8-STABLE, il nuovo Kernel verrà copiato nella directory di root con il nome /kernel, il vecchio Kernel verrà rinominato in /kernel.old.

    -r-xr-xr-x   1 root  wheel  4227598 Aug 18 20:54 kernel*
    -r-xr-xr-x   1 root  wheel  4122347 Apr  3 12:53 kernel.GENERIC*
    -r-xr-xr-x   1 root  wheel  4184781 May  4 20:42 kernel.old*

Nell'esempio possiamo notare un file monolitico del Kernel del 18 Agosto, il file relativo al vecchio Kernel è del 4 Maggio mentre il file relativo del Kernel generico è del 3 Aprile 2003. Nel caso in cui qualcosa dovesse essere andato male forniamo di seguito alcune informazioni che ci consentiranno di ripristinare il sistema.

Fortunatamente FreeBSD è stato concepito con un eccellente meccanismo di recupero del sistema nel caso in cui si dovessero presentare alcune improbabili incompatibilità tra il sistema stesso ed il Kernel appena compilato ed installato. Per quanto concerne la versione 4.8-STABLE sarà infatti sufficente selezionare il tipo di Kernel desiderato servendosi del boot loader di FreeBSD. Potremo accedere direttamente al boot loader di sistema nel momento in cui la macchina si appresta ad eseguire il conteggio di avvio da 0 a 10 utilizzando un semplice tasto, ad eccezione per l'Enter key. Per avviare il vecchio Kernel dovremmo digitare i seguenti comandi

    # unload
    # boot kernel.old

In alternativa potremmo anche digitare il nome del file che abbiamo assegnato in precedenza al vecchio Kernel.

Indietro | Partenza | Avanti
Installare il nuovo Kernel | Risali | Maneggiare i file del Kernel